require 'chunky_png'
require 'ewigkeks/engine'

module Ewigkeks
  mattr_writer :js_class, :png_cookie_name, :cache_cookie_name, :etag_cookie_name

  class << self
    def configure(options = {}, &block)
      options.each do |key, value|
        public_send("#{key}=", value)
      end

      yield(self) if block_given?
    end

    def js_class
      @@js_class ||= 'evercookie'
    end

    def scope
      @@scope ||= 'ewigkeks'
    end

    def scope=(scope)
      @@scope = scope.sub(/\A\/*/, '')
    end

    def png_path
      '/%s/%s' % [scope, 'png']
    end

    def png_cookie_name
      @@png_cookie_name ||= '%s_png' % js_class
    end

    def cache_path
      '/%s/%s' % [scope, 'cache']
    end

    def cache_cookie_name
      @@cache_cookie_name ||= '%s_cache' % js_class
    end

    def etag_path
      '/%s/%s' % [scope, 'etag']
    end

    def etag_cookie_name
      @@etag_cookie_name ||= '%s_etag' % js_class
    end
  end
end
