module Ewigkeks
  class InstallGenerator < Rails::Generators::Base
    source_root File.expand_path(File.join(File.dirname(__FILE__), 'templates'))

    def add_javascript
      ['js', 'js.erb', 'js.coffee'].each do |extension|
        relative_path = 'app/assets/javascripts/application.%s' % extension
        absolute_path = Pathname.new(destination_root).join(relative_path)

        if absolute_path.file?
          append_to_file relative_path do
            "//= require ewigkeks\n"
          end
        end
      end
    end

    def mount_routes
      route 'mount Ewigkeks::Engine => Ewigkeks.scope'
    end

    def copy_initializer
      template 'initializer.rb', 'config/initializers/ewigkeks.rb'
    end
  end
end
